;; -*- mode: Lisp; Syntax: Common-Lisp; Package: triple-cells; -*-
;;;
;;;
;;; Copyright (c) 2008 by Kenneth William Tilton.
;;;

(in-package #:3c)

;; --- ag utils -----------------------

#+test
(progn
  (make-tutorial-store)
  (let ((s (mk-upi "a"))
        (p (new-blank-node)))
    (loop repeat 10
          do (add-triple s (mk-upi (random 10)) p))
    (loop for tr in (get-triples-list :s s)
        do (print (upi->value (predicate tr))))))

(defun triple-value (tr)
  (trc "triple-value called with tr = " tr)
  (if tr
      (progn
        (let ((value (upi->value (object tr))))
          (trc "triple-value value" value)
          value))
    (progn
      (trc "triple-value value nil !")
      nil)))

(defun get-sp (s p)
  (car (get-triples-list :s s :p p :o nil :g nil)))

(defun get-spo (s p o)
  (car (get-triples-list :s s :p p :o o :g nil)))

(defun get-sp-value (s p)
  (triple-value (get-sp s p)))

(defun mk-upi (v)
  (typecase v
    (string (literal v))
    (symbol (mk-upi (symbol-name v)))
    (integer (value->upi v :long))
    (future-part v)
    (otherwise (if (upip v) v
                 (break "not upi-able ~a ~a" (type-of v) v)))))

(defun ensure-triple (s p o)
  (unless (get-spo s p o)
    (add-triple s p o)))

